Index: NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/DIA/diaharm.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/DIA/diaharm.F90	(revision 15634)
+++ NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/DIA/diaharm.F90	(revision 15637)
@@ -73,4 +73,10 @@
       !!----------------------------------------------------------------------
 
+      !JT remove nul from output.namelist.dyn
+      DO jh = 1,jpmax_harmo 
+          tname(jh) = ''
+      END DO
+      !JT remove nul from output.namelist.dyn
+
       IF(lwp) THEN
          WRITE(numout,*)
Index: NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/DIA/diaharm_fast.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/DIA/diaharm_fast.F90	(revision 15634)
+++ NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/DIA/diaharm_fast.F90	(revision 15637)
@@ -378,5 +378,12 @@
                & ln_diaharm_postproc_vel,ln_diaharm_baroc3dvel_only, ln_diaharm_verbose
       !!----------------------------------------------------------------------
+
       !JT
+
+      !JT remove nul from output.namelist.dyn
+      DO jh = 1,jpmax_harmo 
+          tname(jh) = ''
+      END DO
+      !JT remove nul from output.namelist.dyn
       ln_diaharm_fast = .FALSE.
       ln_diaharm_multiyear = .FALSE.
Index: NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/DIU/diurnal_bulk.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/DIU/diurnal_bulk.F90	(revision 15634)
+++ NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/DIU/diurnal_bulk.F90	(revision 15637)
@@ -59,4 +59,6 @@
 902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namdiu in configuration namelist' )      
       !
+      IF(lwm) WRITE ( numond, namdiu )
+
       IF( ln_diurnal_only .AND. ( .NOT. ln_diurnal ) ) THEN
          CALL ctl_stop( "ln_diurnal_only set, but ln_diurnal = FALSE !" )
Index: NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/DOM/dommsk.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/DOM/dommsk.F90	(revision 15634)
+++ NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/DOM/dommsk.F90	(revision 15637)
@@ -100,4 +100,9 @@
       CHARACTER(len = 256)            :: cn_shlat2d_file, cn_shlat2d_var  
       !!
+
+      !JT remove nul from output.namelist.dyn
+      cn_shlat2d_file = ''
+      cn_shlat2d_var = ''
+      !JT remove nul from output.namelist.dyn
       NAMELIST/namlbc/ rn_shlat, ln_vorlat, ln_shlat2d, cn_shlat2d_file, cn_shlat2d_var
       NAMELIST/nambdy/ ln_bdy ,nb_bdy, ln_coords_file, cn_coords_file,         &
Index: NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/SBC/sbcflx.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/SBC/sbcflx.F90	(revision 15634)
+++ NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/SBC/sbcflx.F90	(revision 15637)
@@ -106,5 +106,12 @@
       &                    sn_press, ln_shelf_flx
       ! JT
-
+      !JT remove nul from output.namelist.dyn
+      sn_utau%lname = ''
+      sn_vtau%lname = ''
+      sn_qtot%lname = ''
+      sn_qsr%lname = ''
+      sn_emp%lname = ''
+      sn_press%lname = ''
+      !JT remove nul from output.namelist.dyn
       !!---------------------------------------------------------------------
       !
Index: NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/SBC/tideini.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/SBC/tideini.F90	(revision 15634)
+++ NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/SBC/tideini.F90	(revision 15637)
@@ -59,4 +59,10 @@
                   &     ln_tide_ramp, rn_scal_load, rdttideramp, dn_love_number, clname
       !!----------------------------------------------------------------------
+
+
+      
+      DO jk = 1, jpmax_harmo
+          clname(jk) = ''
+      END DO
       !
       ! Read Namelist nam_tide