Index: /branches/UKMO/dev_r5518_GO6_starthour_obsoper/NEMOGCM/CONFIG/SHARED/field_def.xml
===================================================================
--- /branches/UKMO/dev_r5518_GO6_starthour_obsoper/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 15689)
+++ /branches/UKMO/dev_r5518_GO6_starthour_obsoper/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 15690)
@@ -136,33 +136,33 @@
          <!-- The following ones only when ln_stopack_diags is TRUE -->
 
-         <field id="spp_par01" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par02" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par03" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par04" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par05" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par06" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par07" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par08" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par09" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par10" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par11" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par12" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par13" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par14" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par15" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par16" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par17" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par18" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par19" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par20" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par21" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par22" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par23" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par24" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par25" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par26" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par27" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par28" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
-         <field id="spp_par29" long_name="Sample parameter SPP" standard_name="spp_pert_paramter" unit="0-1"     />
+         <field id="spp_par01" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par02" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par03" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par04" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par05" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par06" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par07" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par08" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par09" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par10" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par11" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par12" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par13" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par14" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par15" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par16" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par17" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par18" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par19" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par20" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par21" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par22" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par23" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par24" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par25" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par26" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par27" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par28" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
+         <field id="spp_par29" long_name="Sample parameter SPP" standard_name="spp_pert_parameter" unit="0-1"     />
 
          <field id="ustar_skeb" long_name="Sea Water X Velocity Perturbation" standard_name="sea_water_x_velocity" unit="m/s" grid_ref="grid_U_3D" />
Index: /branches/UKMO/dev_r5518_GO6_starthour_obsoper/NEMOGCM/NEMO/OPA_SRC/STO/stopack.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_starthour_obsoper/NEMOGCM/NEMO/OPA_SRC/STO/stopack.F90	(revision 15689)
+++ /branches/UKMO/dev_r5518_GO6_starthour_obsoper/NEMOGCM/NEMO/OPA_SRC/STO/stopack.F90	(revision 15690)
@@ -785,5 +785,5 @@
    SUBROUTINE stopack_report
       !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE spp_stats ***
+      !!                  ***  ROUTINE stopack_report ***
       !!
       !! ** Purpose :  Report at the end of the run
Index: /branches/UKMO/dev_r5518_GO6_starthour_obsoper/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- /branches/UKMO/dev_r5518_GO6_starthour_obsoper/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 15689)
+++ /branches/UKMO/dev_r5518_GO6_starthour_obsoper/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 15690)
@@ -499,5 +499,5 @@
                             CALL dia_hsb_init   ! heat content, salt content and volume budgets
                             CALL     trd_init   ! Mixed-layer/Vorticity/Integral constraints trends
-	                          CALL stopack_init   ! STOPACK scheme                            
+                            CALL stopack_init   ! STOPACK scheme                            
                             CALL    bias_init   ! Pressure correction bias
       IF( lk_diaobs     ) THEN                  ! Observation & model comparison