Index: NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/BDY/bdydta.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/BDY/bdydta.F90	(revision 15689)
+++ NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/BDY/bdydta.F90	(revision 15729)
@@ -291,4 +291,64 @@
          ENDIF
 
+      !! JT 
+
+
+        
+        WRITE(*,*) 'JTsshw:',jbdy,nimpp,njmpp,idx_bdy(jbdy)%nblenrim(igrd)  
+
+        igrd = 1
+        DO ib = 1, idx_bdy(jbdy)%nblenrim(igrd)  
+           ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+           ij   = idx_bdy(jbdy)%nbj(ib,igrd)
+           WRITE(*,*) 'JTsshv:',jbdy,nimpp+ii,njmpp+ij,dta_alias%ssh(ib) , tmask(ii,ij,1), sshn(ii,ij)
+        END DO
+
+
+      !! JT I think this need to go here. The previous location didn't have an affect on the model. 
+      !       I think when time splitting, ln_dynspg_ts, you weren't seeing this effect, so trying it before the time splitting. 
+      !
+      ! 
+      ! davbyr - add a shift to the boundary + free elevation Enda, JT from NEMO RAN 3.6
+
+        
+         IF(lwp) WRITE(numout,*) 'bdydta nambdy_ssh: lneed_ssh',kt, jbdy, dta_bdy(jbdy)%lneed_ssh, idx_bdy(jbdy)%nblenrim(igrd) 
+
+
+         IF( dta_bdy(jbdy)%lneed_ssh ) THEN
+
+
+            igrd = 1
+            DO ib = 1, idx_bdy(jbdy)%nblenrim(igrd)   ! ssh is used only on the rim
+               ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+               ij   = idx_bdy(jbdy)%nbj(ib,igrd)
+               dta_alias%ssh(ib) = dta_alias%ssh(ib) + rn_ssh_shift(jbdy) * tmask(ii,ij,1)
+            END DO
+
+             IF( .NOT. dta_bdy(jbdy)%lforced_ssh ) THEN
+                 WRITE(*,*) 'bdydta nambdy_ssh: NOT lforced_ssh == True',kt, jbdy, dta_bdy(jbdy)%lforced_ssh
+
+                 igrd = 1
+                 DO ib = 1, idx_bdy(jbdy)%nblenrim(igrd)   ! ssh is used only on the rim
+                    ii   = idx_bdy(jbdy)%nbi(ib,igrd)
+                    ij   = idx_bdy(jbdy)%nbj(ib,igrd)
+                    WRITE(*,*) 'JTssh:',jbdy, nproc,narea,ii,ij, dta_alias%ssh(ib), dta_bdy(jbdy)%ssh(ib), sshn(ii,ij) * tmask(ii,ij,1), sshn(ii,ij), tmask(ii,ij,1)
+                    dta_alias%ssh(ib) = sshn(ii,ij) * tmask(ii,ij,1)
+                    dta_bdy(jbdy)%ssh(ib) = sshn(ii,ij) * tmask(ii,ij,1)
+                 END DO
+
+             ELSE
+                 WRITE(*,*) 'bdydta nambdy_ssh: NOT lforced_ssh == False',kt, jbdy, dta_bdy(jbdy)%lforced_ssh
+             END IF   !.NOT. dta_bdy(jbdy)%lforced_ssh 
+
+         END IF !dta_bdy(jbdy)%lneed_ssh
+
+      !--- END davbyr
+      !! JT I think this need to go here. 
+
+
+
+
+
+
 #if defined key_si3
          IF( dta_alias%lneed_ice .AND. idx_bdy(jbdy)%nblen(1) > 0 ) THEN
@@ -348,22 +408,41 @@
       END DO  ! jbdy
 
-      !! JT I think this need to go here. The previous location didn't have an affect on the model. 
-      !       I think when time splitting, ln_dynspg_ts, you weren't seeing this effect, so trying it before the time splitting. 
-      !
-      ! 
-      ! davbyr - add a shift to the boundary + free elevation Enda, JT from NEMO RAN 3.6
-      DO jbdy = 1, nb_bdy
-         IF( dta_bdy(jbdy)%lneed_ssh ) THEN
-            igrd  = 1
-            DO ib = 1, idx_bdy(jbdy)%nblenrim(igrd)   ! ssh is used only on the rim
-                ii = idx_bdy(jbdy)%nbi(ib,igrd)
-                ij = idx_bdy(jbdy)%nbj(ib,igrd)
-                dta_bdy(jbdy)%ssh(ib) = dta_bdy(jbdy)%ssh(ib) + rn_ssh_shift(jbdy) * tmask(ii,ij,1)
-                IF( .NOT. dta_bdy(jbdy)%lforced_ssh ) dta_bdy(jbdy)%ssh(ib) = sshn(ii,ij) * tmask(ii,ij,1)
-             END DO
-         END IF
-      END DO
-      !--- END davbyr
-      !! JT I think this need to go here. 
+!      !! JT I think this need to go here. The previous location didn't have an affect on the model. 
+!      !       I think when time splitting, ln_dynspg_ts, you weren't seeing this effect, so trying it before the time splitting. 
+!      !
+!      ! 
+!      ! davbyr - add a shift to the boundary + free elevation Enda, JT from NEMO RAN 3.6
+!      DO jbdy = 1, nb_bdy
+
+!        
+!         IF(lwp) WRITE(numout,*) 'bdydta nambdy_ssh: lneed_ssh',kt, jbdy, dta_bdy(jbdy)%lneed_ssh
+
+
+!         IF( dta_bdy(jbdy)%lneed_ssh ) THEN
+!        
+!            igrd  = 1
+
+!            DO ib = 1, idx_bdy(jbdy)%nblenrim(igrd)   ! ssh is used only on the rim
+!                ii = idx_bdy(jbdy)%nbi(ib,igrd)
+!                ij = idx_bdy(jbdy)%nbj(ib,igrd)
+!                dta_bdy(jbdy)%ssh(ib) = dta_bdy(jbdy)%ssh(ib) + rn_ssh_shift(jbdy) * tmask(ii,ij,1)
+!             END DO
+
+!             IF( .NOT. dta_bdy(jbdy)%lforced_ssh ) THEN
+!                 IF(lwp) WRITE(numout,*) 'bdydta nambdy_ssh: NOT lforced_ssh == True',kt, jbdy, dta_bdy(jbdy)%lforced_ssh
+!                 DO ib = 1, idx_bdy(jbdy)%nblenrim(igrd)   ! ssh is used only on the rim
+!                    ii = idx_bdy(jbdy)%nbi(ib,igrd)
+!                    ij = idx_bdy(jbdy)%nbj(ib,igrd)
+!                    dta_bdy(jbdy)%ssh(ib) = sshn(ii,ij) * tmask(ii,ij,1)
+!                 END DO
+!             ELSE
+!                 IF(lwp) WRITE(numout,*) 'bdydta nambdy_ssh: NOT lforced_ssh == False',kt, jbdy, dta_bdy(jbdy)%lforced_ssh
+!             END IF   !.NOT. dta_bdy(jbdy)%lforced_ssh 
+
+!         END IF !dta_bdy(jbdy)%lneed_ssh
+
+!      END DO ! jbdy
+!      !--- END davbyr
+!      !! JT I think this need to go here. 
 
 
Index: NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/SBC/tide_mod.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/SBC/tide_mod.F90	(revision 15689)
+++ NEMO/branches/UKMO/NEMO_4.0.4_CO9_shelf_climate/src/OCE/SBC/tide_mod.F90	(revision 15729)
@@ -122,28 +122,26 @@
           ENDIF
           
-          IF( lwp ) THEN
-
-              IF ( ln_tide_drift   ) THEN
-                  WRITE(numout,*) "       tides360: Tides continuous so equinoctal tides drift through the year,"
-                  WRITE(numout,*) "                 as the S2-K2 beating occurs 5 days later every year."
-              ENDIF
-
-              IF ( ln_tide_compress   ) THEN
-                  WRITE(numout,*) "       tides360: The Tropical Year (and so some tidal periods) are compressed,"
-                  WRITE(numout,*) "                 so the tides repeat with an annual cycle, so the "
-                  WRITE(numout,*) "                 the S2-K2 beating is fixed relative to the calendar, but the "
-                  WRITE(numout,*) "                 M2 period varies slightly."
-                  WRITE(numout,*) "                 Use with care, as this requires more work."
-              ENDIF
-
-              IF ( ( .NOT. ln_tide_drift  ) .AND. ( .NOT. ln_tide_compress ) ) THEN
-                  WRITE(numout,*) "       tides360: Use the default NEMO tide code, where the tides are reset "
-                  WRITE(numout,*) "                 at the beginning of each month, leading to a slight discontinuity"
-                  WRITE(numout,*) "                 in the tides, and making tidal analysis difficult."
-              ENDIF
+
+          IF ( ln_tide_drift   ) THEN
+              WRITE(numout,*) "       tides360: Tides continuous so equinoctal tides drift through the year,"
+              WRITE(numout,*) "                 as the S2-K2 beating occurs 5 days later every year."
           ENDIF
 
+          IF ( ln_tide_compress   ) THEN
+              WRITE(numout,*) "       tides360: The Tropical Year (and so some tidal periods) are compressed,"
+              WRITE(numout,*) "                 so the tides repeat with an annual cycle, so the "
+              WRITE(numout,*) "                 the S2-K2 beating is fixed relative to the calendar, but the "
+              WRITE(numout,*) "                 M2 period varies slightly."
+              WRITE(numout,*) "                 Use with care, as this requires more work."
+          ENDIF
+
+          IF ( ( .NOT. ln_tide_drift  ) .AND. ( .NOT. ln_tide_compress ) ) THEN
+              WRITE(numout,*) "       tides360: Use the default NEMO tide code, where the tides are reset "
+              WRITE(numout,*) "                 at the beginning of each month, leading to a slight discontinuity"
+              WRITE(numout,*) "                 in the tides, and making tidal analysis difficult."
+          ENDIF
+
       ELSE        
-         IF( lwp )  WRITE(numout,*) "       tides360: Gregorian calendar so using standard tides"
+          WRITE(numout,*) "       tides360: Gregorian calendar so using standard tides"
       ENDIF
 